MS_DEF_PROV_A         		equ "Microsoft Base Cryptographic Provider v1.0" 
MS_DEF_PROV           		equ "Microsoft Base Cryptographic Provider v1.0"
MS_ENHANCED_PROV_A    		equ "Microsoft Enhanced Cryptographic Provider v1.0"
MS_ENHANCED_PROV      		equ "Microsoft Enhanced Cryptographic Provider v1.0"
MS_DEF_RSA_SIG_PROV_A 		equ "Microsoft RSA Signature Cryptographic Provider"
MS_DEF_RSA_SIG_PROV   		equ "Microsoft RSA Signature Cryptographic Provider"
MS_DEF_RSA_SCHANNEL_PROV_A 	equ "Microsoft Base RSA SChannel Cryptographic Provider"
MS_DEF_RSA_SCHANNEL_PROV  	equ "Microsoft Base RSA SChannel Cryptographic Provider"
MS_ENHANCED_RSA_SCHANNEL_PROV_A equ "Microsoft Enhanced RSA SChannel Cryptographic Provider"
MS_ENHANCED_RSA_SCHANNEL_PROV  	equ "Microsoft Enhanced RSA SChannel Cryptographic Provider"
MS_DEF_DSS_PROV_A   		equ "Microsoft Base DSS Cryptographic Provider"
MS_DEF_DSS_PROV  		equ "Microsoft Base DSS Cryptographic Provider"
MS_DEF_DSS_DH_PROV_A 		equ "Microsoft Base DSS and Diffie-Hellman Cryptographic Provider"
MS_DEF_DSS_DH_PROV   		equ "Microsoft Base DSS and Diffie-Hellman Cryptographic Provider"
szOID_RSA         equ      "1.2.840.113549"
szOID_PKCS        equ      "1.2.840.113549.1"
szOID_RSA_HASH    equ      "1.2.840.113549.2"
szOID_RSA_ENCRYPT equ      "1.2.840.113549.3"

szOID_PKCS_1      equ      "1.2.840.113549.1.1"
szOID_PKCS_2      equ      "1.2.840.113549.1.2"
szOID_PKCS_3      equ      "1.2.840.113549.1.3"
szOID_PKCS_4      equ      "1.2.840.113549.1.4"
szOID_PKCS_5      equ      "1.2.840.113549.1.5"
szOID_PKCS_6      equ      "1.2.840.113549.1.6"
szOID_PKCS_7      equ      "1.2.840.113549.1.7"
szOID_PKCS_8      equ      "1.2.840.113549.1.8"
szOID_PKCS_9      equ      "1.2.840.113549.1.9"
szOID_PKCS_10     equ      "1.2.840.113549.1.10"

szOID_RSA_RSA      equ      "1.2.840.113549.1.1.1"
szOID_RSA_MD2RSA   equ     "1.2.840.113549.1.1.2"
szOID_RSA_MD4RSA   equ     "1.2.840.113549.1.1.3"
szOID_RSA_MD5RSA   equ     "1.2.840.113549.1.1.4"
szOID_RSA_SHA1RSA  equ     "1.2.840.113549.1.1.5"
szOID_RSA_SETOAEP_RSA equ  "1.2.840.113549.1.1.6"

szOID_RSA_data          equ "1.2.840.113549.1.7.1"
szOID_RSA_signedData    equ "1.2.840.113549.1.7.2"
szOID_RSA_envelopedData equ "1.2.840.113549.1.7.3"
szOID_RSA_signEnvData   equ "1.2.840.113549.1.7.4"
szOID_RSA_digestedData  equ "1.2.840.113549.1.7.5"
szOID_RSA_hashedData    equ "1.2.840.113549.1.7.5"
szOID_RSA_encryptedData equ "1.2.840.113549.1.7.6"

szOID_RSA_emailAddr     equ "1.2.840.113549.1.9.1"
szOID_RSA_unstructName  equ "1.2.840.113549.1.9.2"
szOID_RSA_contentType   equ "1.2.840.113549.1.9.3"
szOID_RSA_messageDigest equ "1.2.840.113549.1.9.4"
szOID_RSA_signingTime   equ "1.2.840.113549.1.9.5"
szOID_RSA_counterSign   equ "1.2.840.113549.1.9.6"
szOID_RSA_challengePwd  equ "1.2.840.113549.1.9.7"
szOID_RSA_unstructAddr  equ "1.2.840.113549.1.9.8"
szOID_RSA_extCertAttrs  equ "1.2.840.113549.1.9.9"
szOID_RSA_SMIMECapabilities equ "1.2.840.113549.1.9.15"
szOID_RSA_preferSignedData equ "1.2.840.113549.1.9.15.1"

szOID_RSA_MD2           equ "1.2.840.113549.2.2"
szOID_RSA_MD4           equ "1.2.840.113549.2.4"
szOID_RSA_MD5           equ "1.2.840.113549.2.5"

szOID_RSA_RC2CBC        equ "1.2.840.113549.3.2"
szOID_RSA_RC4           equ "1.2.840.113549.3.4"
szOID_RSA_DES_EDE3_CBC  equ "1.2.840.113549.3.7"
szOID_RSA_RC5_CBCPad    equ "1.2.840.113549.3.9"

; ITU-T UsefulDefinitions
szOID_DS                equ "2.5"
szOID_DSALG             equ "2.5.8"
szOID_DSALG_CRPT        equ "2.5.8.1"
szOID_DSALG_HASH        equ "2.5.8.2"
szOID_DSALG_SIGN        equ "2.5.8.3"
szOID_DSALG_RSA         equ "2.5.8.1.1"
szOID_OIW               equ "1.3.14"
szOID_OIWSEC            equ "1.3.14.3.2"
szOID_OIWSEC_md4RSA     equ "1.3.14.3.2.2"
szOID_OIWSEC_md5RSA     equ "1.3.14.3.2.3"
szOID_OIWSEC_md4RSA2    equ "1.3.14.3.2.4"
szOID_OIWSEC_desECB     equ "1.3.14.3.2.6"
szOID_OIWSEC_desCBC     equ "1.3.14.3.2.7"
szOID_OIWSEC_desOFB     equ "1.3.14.3.2.8"
szOID_OIWSEC_desCFB     equ "1.3.14.3.2.9"
szOID_OIWSEC_desMAC     equ "1.3.14.3.2.10"
szOID_OIWSEC_rsaSign    equ "1.3.14.3.2.11"
szOID_OIWSEC_dsa        equ "1.3.14.3.2.12"
szOID_OIWSEC_shaDSA     equ "1.3.14.3.2.13"
szOID_OIWSEC_mdc2RSA    equ "1.3.14.3.2.14"
szOID_OIWSEC_shaRSA     equ "1.3.14.3.2.15"
szOID_OIWSEC_dhCommMod  equ "1.3.14.3.2.16"
szOID_OIWSEC_desEDE     equ "1.3.14.3.2.17"
szOID_OIWSEC_sha        equ "1.3.14.3.2.18"
szOID_OIWSEC_mdc2       equ "1.3.14.3.2.19"
szOID_OIWSEC_dsaComm    equ "1.3.14.3.2.20"
szOID_OIWSEC_dsaCommSHA equ "1.3.14.3.2.21"
szOID_OIWSEC_rsaXchg    equ "1.3.14.3.2.22"
szOID_OIWSEC_keyHashSeal equ "1.3.14.3.2.23"
szOID_OIWSEC_md2RSASign equ "1.3.14.3.2.24"
szOID_OIWSEC_md5RSASign equ "1.3.14.3.2.25"
szOID_OIWSEC_sha1       equ "1.3.14.3.2.26"
szOID_OIWSEC_dsaSHA1    equ "1.3.14.3.2.27"
szOID_OIWSEC_dsaCommSHA1 equ "1.3.14.3.2.28"
szOID_OIWSEC_sha1RSASign equ "1.3.14.3.2.29"
szOID_OIWDIR            equ "1.3.14.7.2"
szOID_OIWDIR_CRPT       equ "1.3.14.7.2.1"
szOID_OIWDIR_HASH       equ "1.3.14.7.2.2"
szOID_OIWDIR_SIGN       equ "1.3.14.7.2.3"
szOID_OIWDIR_md2        equ "1.3.14.7.2.2.1"
szOID_OIWDIR_md2RSA     equ "1.3.14.7.2.3.1"

; INFOSEC Algorithms
szOID_INFOSEC                       equ "2.16.840.1.101.2.1"
szOID_INFOSEC_sdnsSignature         equ "2.16.840.1.101.2.1.1.1"
szOID_INFOSEC_mosaicSignature       equ "2.16.840.1.101.2.1.1.2"
szOID_INFOSEC_sdnsConfidentiality   equ "2.16.840.1.101.2.1.1.3"
szOID_INFOSEC_mosaicConfidentiality equ "2.16.840.1.101.2.1.1.4"
szOID_INFOSEC_sdnsIntegrity         equ "2.16.840.1.101.2.1.1.5"
szOID_INFOSEC_mosaicIntegrity       equ "2.16.840.1.101.2.1.1.6"
szOID_INFOSEC_sdnsTokenProtection   equ "2.16.840.1.101.2.1.1.7"
szOID_INFOSEC_mosaicTokenProtection equ "2.16.840.1.101.2.1.1.8"
szOID_INFOSEC_sdnsKeyManagement     equ "2.16.840.1.101.2.1.1.9"
szOID_INFOSEC_mosaicKeyManagement   equ "2.16.840.1.101.2.1.1.10"
szOID_INFOSEC_sdnsKMandSig          equ "2.16.840.1.101.2.1.1.11"
szOID_INFOSEC_mosaicKMandSig        equ "2.16.840.1.101.2.1.1.12"
szOID_INFOSEC_SuiteASignature       equ "2.16.840.1.101.2.1.1.13"
szOID_INFOSEC_SuiteAConfidentiality equ "2.16.840.1.101.2.1.1.14"
szOID_INFOSEC_SuiteAIntegrity       equ "2.16.840.1.101.2.1.1.15"
szOID_INFOSEC_SuiteATokenProtection equ "2.16.840.1.101.2.1.1.16"
szOID_INFOSEC_SuiteAKeyManagement   equ "2.16.840.1.101.2.1.1.17"
szOID_INFOSEC_SuiteAKMandSig        equ "2.16.840.1.101.2.1.1.18"
szOID_INFOSEC_mosaicUpdatedSig      equ "2.16.840.1.101.2.1.1.19"
szOID_INFOSEC_mosaicKMandUpdSig     equ "2.16.840.1.101.2.1.1.20"
szOID_INFOSEC_mosaicUpdatedInteg    equ "2.16.840.1.101.2.1.1.21"

;- Return constants for CryptAquireContext
; ERR+_INVALID_PARAMETER          equ defined in win32api.inc
; ERR+_NOT_ENOUGH_MEM+Y          equ defined in win32api.inc


PROV_RSA_FULL           equ 1
PROV_RSA_SIG            equ 2
PROV_DSS                equ 3
PROV_FORTEZZA           equ 4
PROV_MS_EXCHANGE        equ 5
PROV_SSL                equ 6
PROV_RSA_SCHANNEL       equ 12
PROV_DSS_DH             equ 13
PROV_EC_ECDSA_SIG       equ 14
PROV_EC_ECNRA_SIG       equ 15
PROV_EC_ECDSA_FULL      equ 16
PROV_EC_ECNRA_FULL      equ 17
PROV_SPYRUS_LYNKS       equ 20

; dwFlags definitions F+ CryptAcquireContext
CRYPT_VERIFYCONTEXT     equ 0F0000000h
CRYPT_NEWKEYSET         equ 00000008h
CRYPT_DELETEKEYSET      equ 00000010h
CRYPT_MACHINE_KEYSET    equ 00000020h

;  CryptSetProvParam
;
PP_CLIENT_HWND          equ 1
PP_CONTEXT_INFO         equ 11
PP_KEYEXCHANGE_KEYSIZE  equ 12
PP_SIGNATURE_KEYSIZE    equ 13
PP_KEYEXCHANGE_ALG      equ 14
PP_SIGNATURE_ALG        equ 15
PP_DELETEKEY            equ 24

;- CryptGetProvParam
;
PP_ENUMALGS             equ 1
PP_ENUMCONTAINERS       equ 2
PP_IMPTYPE              equ 3
PP_NAME                 equ 4
PP_VERSION              equ 5
PP_CONTAINER            equ 6
PP_CHANGE_PASSWORD      equ 7
PP_KEYSET_SEC_DESCR     equ 8
PP_CERTCHAIN            equ 9
PP_KEY_TYPE_SUBTYPE     equ 10
PP_PROVTYPE             equ 16
PP_KEYSTORAGE           equ 17
PP_APPLI_CERT           equ 18
PP_SYM_KEYSIZE          equ 19
PP_SESSION_KEYSIZE      equ 20
PP_UI_PROMPT            equ 21
PP_ENUMALGS_EX          equ 22

;  dwFlag definitions F+ CryptGenKey
CRYPT_EXPORTABLE         equ 00000001h
CRYPT_USER_PROTECTED    equ 00000002h
CRYPT_CREATE_SALT       equ 00000004h
CRYPT_UPDATE_KEY        equ 00000008h
CRYPT_NO_SALT           equ 00000010h
CRYPT_PREGEN            equ 00000040h
CRYPT_RECIPIENT         equ 00000010h
CRYPT_INITIATOR          equ 00000040h
CRYPT_ONLINE            equ 00000080h
CRYPT_SF                equ 00000100h
CRYPT_CREATE_IV         equ 00000200h
CRYPT_KEK               equ 00000400h
CRYPT_DATA_KEY          equ 00000800h

;  dwFlags definitions F+ CryptDeriveKey
CRYPT_SERVER            equ 00000400h

KEY_LENGTH_MASK         equ 0FFFF0000h

;  dwFlag definitions F+ CryptExp+tKey
CRYPT_Y_ONLY            equ 00000001h
CRYPT_SSL2_SLUMMING     equ 00000002h

;  dwFlags definitions F+ CryptHashSessionKey
CRYPT_LITTLE_ENDIAN    equ 00000001h

;  dwFlag definitions F+ CryptSetProviderEx And CryptGetDefaultProvider
CRYPT_MACHINE_DEFAULT   equ 00000001h
CRYPT_USER_DEFAULT      equ 00000002h
CRYPT_DELETE_DEFAULT    equ 00000004h

;  exp+ted key blob definitions
SIMPLEBLOB              equ 1
PUBLICKEYBLOB           equ 6
PRIVATEKEYBLOB          equ 7
PLAINTEXTKEYBLOB        equ 8

AT_KEYEXCHANGE          equ 1
AT_SIGNATURE            equ 2

CRYPT_USERDATA          equ 1

;  dwParam
KP_IV                   equ 1       ;  Initialization vect+
KP_SALT                 equ 2       ;  Salt value
KP_PADDING              equ 3       ;  Padding values
KP_MODE                 equ 4       ;  Mode of the cipher
KP_MODE_BITS            equ 5       ;  Number of bits To feedback
KP_PERMISSIONS          equ 6       ;  Key permissions Dw+d
KP_ALGID                equ 7       ;  Key alg+ithm
KP_BLOCKLEN             equ 8       ;  Block Size of the cipher
KP_KEYLEN               equ 9       ;  Length of key In bits
KP_SALT_EX              equ 10      ;  Length of salt In bytes
KP_P                    equ 11      ;  DSS/Diffie-Hellman P value
KP_G                    equ 12      ;  DSS/Diffie-Hellman G value
KP_Q                    equ 13      ;  DSS Q value
KP_X                    equ 14      ;  Diffie-Hellman X value
KP_Y                    equ 15      ;  Y value
KP_RA                   equ 16      ;  F+tezza RA value
KP_RB                   equ 17      ;  F+tezza RB value
KP_INFO                 equ 18      ;  F+ putting inf+mation into an RSA envelope
KP_EFFECTIVE_KEYLEN     equ 19      ;  setting And getting RC2 effective key length
KP_SCHANNEL_ALG         equ 20      ;  F+ setting the Secure Channel alg+ithms
KP_CLIENT_RANDOM        equ 21      ;  F+ setting the Secure Channel Client Random Data
KP_SERVER_RANDOM        equ 22      ;  F+ setting the Secure Channel Server Random Data
KP_RP                   equ 23
KP_PRECOMP_MD5          equ 24
KP_PRECOMP_SHA          equ 25
KP_CERTIFICATE          equ 26      ;  F+ setting Secure Channel certificate Data (PCT1)
KP_CLEAR_KEY            equ 27      ;  F+ setting Secure Channel clear key Data (PCT1)
KP_PUB_EX_LEN           equ 28
KP_PUB_EX_VAL           equ 29

;  KP_PADDING
PKCS5_PADDING           equ 1       ;  PKCS 5 (sec 6.2) padding method
RANDOM_PADDING          equ 2
ZERO_PADDING            equ 3

;  KP_MODE
CRYPT_MODE_CBC          equ 1       ;  Cipher block chaining
CRYPT_MODE_ECB          equ 2       ;  Electronic code book
CRYPT_MODE_OFB          equ 3       ;  Output feedback mode
CRYPT_MODE_CFB          equ 4       ;  Cipher feedback mode
CRYPT_MODE_CTS          equ 5       ;  Ciphertext stealing mode

;  KP_PERMISSIONS
CRYPT_ENCRYPT           equ 0001h  ;  Allow encryption
CRYPT_DECRYPT           equ 0002h  ;  Allow decryption
CRYPT_EXPORT             equ 0004h  ;  Allow key To be exp+ted
CRYPT_READ              equ 0008h  ;  Allow parameters To be Read
CRYPT_WRITE             equ 0010h  ;  Allow parameters To be Set
CRYPT_MAC               equ 0020h  ;  Allow MACs To be used With key
CRYPT_EXPORT_KEY         equ 0040h  ;  Allow key To be used F+ exp+ting keys
CRYPT_IMPORT_KEY         equ 0080h  ;  Allow key To be used F+ imp+ting keys

HP_ALGID                equ 0001  ;  Hash alg+ithm
HP_HASHVAL              equ 0002  ;  Hash value
HP_HASHSIZE             equ 0004  ;  Hash value Size
HP_HMAC_INFO            equ 0005  ;  inf+mation F+ creating an HMAC

CRYPT_FAILED            equ FALSE
CRYPT_SUCCEED           equ TRUE

;
;  CryptGetProvParam
;
PP_ENUMALGS             equ 1
PP_ENUMCONTAINERS       equ 2
PP_IMPTYPE              equ 3
PP_NAME                 equ 4
PP_VERSION              equ 5
PP_CONTAINER            equ 6
PP_CHANGE_PASSWORD       equ 7
PP_KEYSET_SEC_DESCR     equ 8       ;  Get/Set security descript+ of keyset
PP_CERTCHAIN            equ 9       ;  F+ retrieving certificates From tokens
PP_KEY_TYPE_SUBTYPE     equ 10
PP_PROVTYPE             equ 16
PP_KEYSTORAGE            equ 17
PP_APPLI_CERT           equ 18
PP_SYM_KEYSIZE          equ 19
PP_SESSION_KEYSIZE      equ 20
PP_UI_PROMPT            equ 21
PP_ENUMALGS_EX          equ 22

CRYPT_FIRST             equ 1
CRYPT_NEXT              equ 2

CRYPT_IMPL_HARDWARE     equ 1
CRYPT_IMPL_SOFTWARE     equ 2
CRYPT_IMPL_MIXED        equ 3
CRYPT_IMPL_UNKNOWN      equ 4

;  key storage flags
CRYPT_SEC_DESCR         equ 00000001h
CRYPT_PSTORE            equ 00000002h
CRYPT_UI_PROMPT         equ 00000004h

;  protocol flags
CRYPT_FLAG_PCT1         equ 0001h
CRYPT_FLAG_SSL2         equ 0002h
CRYPT_FLAG_SSL3         equ 0004h
CRYPT_FLAG_TLS1         equ 0008h

;
; CryptSetProvParam
;
PP_CLIENT_HWND          equ 1
PP_CONTEXT_INFO		equ 	11
PP_KEYEXCHANGE_KEYSIZE	equ 12
PP_SIGNATURE_KEYSIZE    equ 13
PP_KEYEXCHANGE_ALG      equ 14
PP_SIGNATURE_ALG        equ 15
PP_DELETEKEY            equ 24

PROV_RSA_FULL           equ 1
PROV_RSA_SIG            equ 2
PROV_DSS                equ 3
PROV_FORTEZZA           equ 4
PROV_MS_EXCHANGE        equ 5
PROV_SSL                equ 6
PROV_RSA_SCHANNEL       equ 12
PROV_DSS_DH             equ 13
PROV_EC_ECDSA_SIG       equ 14
PROV_EC_ECNRA_SIG       equ 15
PROV_EC_ECDSA_FULL      equ 16
PROV_EC_ECNRA_FULL      equ 17
PROV_SPYRUS_LYNKS       equ 20

;
;  STT defined Providers
;
PROV_STT_MER            equ 7
PROV_STT_ACQ            equ 8
PROV_STT_BRND           equ 9
PROV_STT_ROOT           equ 10
PROV_STT_ISS            equ 11

;
; Algoithm IDs And Flags
;
; Algoithm classes
ALG_CLASS_ANY                   equ 0
ALG_CLASS_SIGNATURE             equ 8192      ;(1 << 13)        ;8192
ALG_CLASS_MSG_ENCRYPT           equ 16384     ;(2 << 13)        ;16384
ALG_CLASS_DATA_ENCRYPT          equ 24576     ;(3 << 13)        ;24576
ALG_CLASS_HASH                  equ 32768     ;(4 << 13)        ;32768
ALG_CLASS_KEY_EXCHANGE          equ 40960     ;(5 << 13)        ;40960

; Algoithm types
ALG_TYPE_ANY                    equ 0
ALG_TYPE_DSS                    equ 512       ;(1 << 9)         ;512
ALG_TYPE_RSA                    equ 1024      ;(2 << 9)         ;1024
ALG_TYPE_BLOCK                  equ 1536      ;(3 << 9)         ;1536
ALG_TYPE_STREAM                 equ 2048      ;(4 << 9)         ;2048
ALG_TYPE_DH                     equ 2560      ;(5 << 9)         ;2560
ALG_TYPE_SECURECHANNEL          equ 3072      ;(6 << 9)         ;3072
;  Generic Sub-ids
ALG_SID_ANY                     equ 0

;  Some RSA Sub-ids
ALG_SID_RSA_ANY                 equ 0
ALG_SID_RSA_PKCS                equ 1
ALG_SID_RSA_MSATWORK             equ 2
ALG_SID_RSA_ENTRUST             equ 3
ALG_SID_RSA_PGP                 equ 4

;  Some DSS Sub-ids
;
ALG_SID_DSS_ANY                 equ 0
ALG_SID_DSS_PKCS                equ 1
ALG_SID_DSS_DMS                 equ 2

;  Block cipher Sub ids
;  DES sub_ids
ALG_SID_DES                     equ 1
ALG_SID_3DES                    equ 3
ALG_SID_DESX                    equ 4
ALG_SID_IDEA                    equ 5
ALG_SID_CAST                    equ 6
ALG_SID_SAFERSK64               equ 7
ALG_SID_SAFERSK128              equ 8
ALG_SID_3DES_112                equ 9
ALG_SID_CYLINK_MEK              equ 12
ALG_SID_RC5                     equ 13

;  Fotezza Sub-ids
ALG_SID_SKIPJACK                equ 10
ALG_SID_TEK                     equ 11

;  KP_MODE
CRYPT_MODE_CBCI                 equ 6       ;  ANSI CBC Interleaved
CRYPT_MODE_CFBP                 equ 7       ;  ANSI CFB Pipelined
CRYPT_MODE_OFBP                 equ 8       ;  ANSI OFB Pipelined
CRYPT_MODE_CBCOFM               equ 9       ;  ANSI CBC + OF Masking
CRYPT_MODE_CBCOFMI              equ 10      ;  ANSI CBC + OFM Interleaved

;  RC2 Sub-ids
ALG_SID_RC2                     equ 2

;  Stream cipher Sub-ids
ALG_SID_RC4                     equ 1
ALG_SID_SEAL                    equ 2

;  Diffie-Hellman Sub-ids
ALG_SID_DH_SANDF                equ 1
ALG_SID_DH_EPHEM                equ 2
ALG_SID_AGREED_KEY_ANY          equ 3
ALG_SID_KEA                     equ 4

;  Hash Sub ids
ALG_SID_MD2                     equ 1
ALG_SID_MD4                     equ 2
ALG_SID_MD5                     equ 3
ALG_SID_SHA                     equ 4
ALG_SID_SHA1                    equ 4
ALG_SID_MAC                     equ 5
ALG_SID_RIPEMD                  equ 6
ALG_SID_RIPEMD160               equ 7
ALG_SID_SSL3SHAMD5              equ 8
ALG_SID_HMAC                    equ 9

;  secure channel Sub ids
ALG_SID_SSL3_MASTER             equ 1
ALG_SID_SCHANNEL_MASTER_HASH    equ 2
ALG_SID_SCHANNEL_MAC_KEY        equ 3
ALG_SID_PCT1_MASTER             equ 4
ALG_SID_SSL2_MASTER             equ 5
ALG_SID_TLS1_MASTER             equ 6
ALG_SID_SCHANNEL_ENC_KEY        equ 7

;  Our silly example Sub-id
ALG_SID_EXAMPLE                 equ 80

;  algoithm identifier definitions
CALG_MD2           equ (ALG_CLASS_HASH + ALG_TYPE_ANY + ALG_SID_MD2)
CALG_MD4           equ (ALG_CLASS_HASH + ALG_TYPE_ANY + ALG_SID_MD4)
CALG_MD5           equ (ALG_CLASS_HASH + ALG_TYPE_ANY + ALG_SID_MD5)
CALG_SHA           equ (ALG_CLASS_HASH + ALG_TYPE_ANY + ALG_SID_SHA)
CALG_SHA1          equ (ALG_CLASS_HASH + ALG_TYPE_ANY + ALG_SID_SHA1)
CALG_MAC           equ (ALG_CLASS_HASH + ALG_TYPE_ANY + ALG_SID_MAC)
CALG_RSA_SIGN      equ (ALG_CLASS_SIGNATURE  + ALG_TYPE_RSA + ALG_SID_RSA_ANY)
CALG_DSS_SIGN      equ (ALG_CLASS_SIGNATURE + ALG_TYPE_DSS + ALG_SID_DSS_ANY)
CALG_RSA_KEYX      equ (ALG_CLASS_KEY_EXCHANGE + ALG_TYPE_RSA + ALG_SID_RSA_ANY)
CALG_DES           equ (ALG_CLASS_DATA_ENCRYPT + ALG_TYPE_BLOCK + ALG_SID_DES)
CALG_3DES_112      equ (ALG_CLASS_DATA_ENCRYPT + ALG_TYPE_BLOCK + ALG_SID_3DES_112)
CALG_3DES          equ (ALG_CLASS_DATA_ENCRYPT + ALG_TYPE_BLOCK + ALG_SID_3DES)
CALG_RC2           equ (ALG_CLASS_DATA_ENCRYPT + ALG_TYPE_BLOCK + ALG_SID_RC2)
CALG_RC4           equ (ALG_CLASS_DATA_ENCRYPT + ALG_TYPE_STREAM + ALG_SID_RC4)
CALG_SEAL          equ (ALG_CLASS_DATA_ENCRYPT + ALG_TYPE_STREAM + ALG_SID_SEAL)
CALG_DH_SF         equ (ALG_CLASS_KEY_EXCHANGE + ALG_TYPE_DH + ALG_SID_DH_SANDF)
CALG_DH_EPHEM      equ (ALG_CLASS_KEY_EXCHANGE + ALG_TYPE_DH + ALG_SID_DH_EPHEM)
CALG_AGREEDKEY_ANY equ (ALG_CLASS_KEY_EXCHANGE + ALG_TYPE_DH + ALG_SID_AGREED_KEY_ANY)
CALG_KEA_KEYX      equ (ALG_CLASS_KEY_EXCHANGE + ALG_TYPE_DH + ALG_SID_KEA)
CALG_HUGHES_MD5    equ (ALG_CLASS_KEY_EXCHANGE + ALG_TYPE_ANY + ALG_SID_MD5)
CALG_SKIPJACK      equ (ALG_CLASS_DATA_ENCRYPT + ALG_TYPE_BLOCK + ALG_SID_SKIPJACK)
CALG_TEK           equ (ALG_CLASS_DATA_ENCRYPT + ALG_TYPE_BLOCK + ALG_SID_TEK)
CALG_CYLINK_MEK    equ (ALG_CLASS_DATA_ENCRYPT + ALG_TYPE_BLOCK + ALG_SID_CYLINK_MEK)
CALG_SSL3_SHAMD5   	  equ (ALG_CLASS_HASH + ALG_TYPE_ANY + ALG_SID_SSL3SHAMD5)
CALG_SSL3_MASTER          equ (ALG_CLASS_MSG_ENCRYPT + ALG_TYPE_SECURECHANNEL + ALG_SID_SSL3_MASTER)
CALG_SCHANNEL_MASTER_HASH equ ALG_CLASS_MSG_ENCRYPT + ALG_TYPE_SECURECHANNEL + ALG_SID_SCHANNEL_MASTER_HASH)
CALG_SCHANNEL_MAC_KEY   equ (ALG_CLASS_MSG_ENCRYPT + ALG_TYPE_SECURECHANNEL + ALG_SID_SCHANNEL_MAC_KEY)
CALG_SCHANNEL_ENC_KEY   equ (ALG_CLASS_MSG_ENCRYPT + ALG_TYPE_SECURECHANNEL + ALG_SID_SCHANNEL_ENC_KEY)
CALG_PCT1_MASTER        equ (ALG_CLASS_MSG_ENCRYPT + ALG_TYPE_SECURECHANNEL + ALG_SID_PCT1_MASTER)
CALG_SSL2_MASTER        equ (ALG_CLASS_MSG_ENCRYPT + ALG_TYPE_SECURECHANNEL + ALG_SID_SSL2_MASTER)
CALG_TLS1_MASTER        equ (ALG_CLASS_MSG_ENCRYPT + ALG_TYPE_SECURECHANNEL + ALG_SID_TLS1_MASTER)
CALG_RC5                equ (ALG_CLASS_DATA_ENCRYPT + ALG_TYPE_BLOCK + ALG_SID_RC5)
CALG_HMAC               equ (ALG_CLASS_HASH + ALG_TYPE_ANY + ALG_SID_HMAC)

MAXUIDLEN  equ 64
CUR_BLOB_VERSION  equ 2

; Labeling attribute types:
SZOID_COMMON_NAME               equ     "2.5.4.3"  ; case-ignore string
SZOID_SUR_NAME                  equ     "2.5.4.4"  ; case-ignore string
SZOID_DEVICE_SERIAL_NUMBER      equ     "2.5.4.5"  ; printable string

; Geographic attribute types:
SZOID_COUNTRY_NAME              equ     "2.5.4.6"  ; printable 2char string
SZOID_LOCALITY_NAME             equ     "2.5.4.7"  ; case-ignore string
SZOID_STATE_OR_PROVINCE_NAME    equ     "2.5.4.8"  ; case-ignore string
SZOID_STREET_ADDRESS            equ     "2.5.4.9"  ; case-ignore string

; Organizational attribute types:
SZOID_ORGANIZATION_NAME         equ     "2.5.4.10" ; case-ignore string
SZOID_ORGANIZATIONAL_UNIT_NAME  equ     "2.5.4.11" ; case-ignore string
SZOID_TITLE                     equ     "2.5.4.12" ; case-ignore string

; Explanatory attribute types:
SZOID_DESCRIPTION               equ     "2.5.4.13" ; case-ignore string
SZOID_SEARCH_GUIDE              equ     "2.5.4.14"
SZOID_BUSINESS_CATEGORY         equ     "2.5.4.15" ; case-ignore string

; Postal addressing attribute types:
SZOID_POSTAL_ADDRESS            equ     "2.5.4.16"
SZOID_POSTAL_CODE               equ     "2.5.4.17" ; case-ignore string
SZOID_POST_OFFICE_BOX           equ     "2.5.4.18" ; case-ignore string
SZOID_PHYSICAL_DELIVERY_OFFICE_NAME equ "2.5.4.19" ; case-ignore string

; Telecommunications addressing attribute types:
SZOID_TELEPHONE_NUMBER             equ  "2.5.4.20" ; telephone number
SZOID_TELEX_NUMBER                 equ  "2.5.4.21"
SZOID_TELETEXT_TERMINAL_IDENTIFIER equ  "2.5.4.22"
SZOID_FACSIMILE_TELEPHONE_NUMBER   equ  "2.5.4.23"
SZOID_X21_ADDRESS                  equ  "2.5.4.24" ; numeric string
SZOID_INTERNATIONAL_ISDN_NUMBER    equ  "2.5.4.25" ; numeric string
SZOID_REGISTERED_ADDRESS           equ  "2.5.4.26"
SZOID_DESTINATION_INDICATOR        equ  "2.5.4.27" ; printable string

; Preference attribute types:
SZOID_PREFERRED_DELIVERY_METHOD     equ "2.5.4.28"

; OSI application attribute types:
SZOID_PRESENTATION_ADDRESS          equ "2.5.4.29"
SZOID_SUPPORTED_APPLICATION_CONTEXT equ "2.5.4.30"

; Relational application attribute types:
SZOID_MEMBER                        equ "2.5.4.31"
SZOID_OWNER                         equ "2.5.4.32"
SZOID_ROLE_OCCUPANT                 equ "2.5.4.33"
SZOID_SEE_ALSO                      equ "2.5.4.34"

; Security attribute types:
SZOID_USER_PASSWORD                 equ "2.5.4.35"
SZOID_USER_CERTIFICATE              equ "2.5.4.36"
SZOID_CA_CERTIFICATE                equ "2.5.4.37"
SZOID_AUTHORITY_REVOCATION_LIST     equ "2.5.4.38"
SZOID_CERTIFICATE_REVOCATION_LIST   equ "2.5.4.39"
SZOID_CROSS_CERTIFICATE_PAIR        equ "2.5.4.40"

;Undocumented attribute types???
;SZOID_???                         equ "2.5.4.41"
SZOID_GIVEN_NAME                    equ "2.5.4.42" ; case-ignore string
SZOID_INITIALS                      equ "2.5.4.43" ; case-ignore string

; Pilot user attribute types:
SZOID_DOMAIN_COMPONENT  equ  "0.9.2342.19200300.100.1.25" ; IA5 string

CERT_RDN_ANY_TYPE               equ  0
CERT_RDN_ENCODED_BLOB           equ  1
CERT_RDN_OCTET_STRING           equ  2
CERT_RDN_NUMERIC_STRING         equ  3
CERT_RDN_PRINTABLE_STRING       equ  4
CERT_RDN_TELETEX_STRING         equ  5
CERT_RDN_T61_STRING             equ  5
CERT_RDN_VIDEOTEX_STRING        equ  6
CERT_RDN_IA5_STRING             equ  7
CERT_RDN_GRAPHIC_STRING         equ  8
CERT_RDN_VISIBLE_STRING         equ  9
CERT_RDN_ISO646_STRING          equ  9
CERT_RDN_GENERAL_STRING         equ  10
CERT_RDN_UNIVERSAL_STRING       equ  11
CERT_RDN_INT4_STRING            equ  11
CERT_RDN_BMP_STRING             equ  12
CERT_RDN_UNICODE_STRING         equ  12
